#
# $Id: filter_nnrpd.pl,v 1.1.1.1 1997/08/04 04:03:49 gpalmer Exp $
#
# Sample perl filtering code for nnrpd hook.
#

### Change this to match your site.    ###
do "/news/bin/hmac.pl";

## CHANGE to your domain name ##
my $domain = "meow.invalid";

use MIME::Base64;

sub filter_post {
    my $rval = "" ;		# assume we'll accept.
    admin_cancel_lock();
    $rval ;
}

# See if the poster has included a cancel lock.  If yes, we add one
# too so that the news account can cancel if necessary.
sub admin_cancel_lock {
    # $USE_MD5: 1 for MD5, 0 for SHA-1
    my $USE_MD5 = 0;

    my ($secret, $temp_key, $cancel_key, $MD5, $SHA1, @super_seed);

    # Add an admin cancel lock iff there is one already present.
    if ($hdr{'Cancel-Lock'}) {
	# Get my password.
	open(SECRET, "$ENV{HOME}/.cancelsecret")
				or die "no .cancelsecret, stopped";

	$secret = "";
	while(<SECRET>) { $secret .= $_ }
	close SECRET;
	die "Empty .cancelsecret file, stopped" if (not $secret);

	if (not $hdr{'Message-ID'}) { $hdr{'Message-ID'} = innid($domain) }

	# Make the cancel lock.
	if ($USE_MD5) {
	    $MD5 = new MD5;
	    $temp_key = encode_base64(HMAC_MD5($secret,
					$hdr{'Message-ID'}, 0));
	    chomp $temp_key;
	    #$hdr{'X-Admin-Key'} = "md5:" . encode_base64($temp_key);
	    #chomp $hdr{'X-Admin-Key'};
	    $hdr{'Cancel-Lock'} .= "\n\tmd5:" .
				encode_base64($MD5->hash($temp_key));
	}
	else {
	    $SHA1 = new SHA;
	    $temp_key = encode_base64(HMAC_SHA1($secret,
					$hdr{'Message-ID'}, 0));
	    chomp $temp_key;
	    #$hdr{'X-Admin-Key'} = "sha1:" . encode_base64($temp_key);
	    #chomp $hdr{'X-Admin-Key'};
	    $hdr{'Cancel-Lock'} .= "\n\tsha1:" .
				encode_base64($SHA1->hash($temp_key));
	}
	chomp $hdr{'Cancel-Lock'};
        $modify_headers=1;
    }
}

# Convert an integer to an arbitrary character set
# $tm: integer to encode   $alfa: character set string
sub intcode {
    my $tm = shift;
    my $alfa = shift;
    my $radix = length($alfa);
    my $id;
    while (1 < $tm) {
	$mod =  $tm % $radix;
	$id = substr($alfa, $mod, 1) . $id;
	$tm = $tm / $radix;
    }
    return $id;
}

# Generate an INN-style message ID.
$innid_serial = 0;
$innid_oldtime = 0;
sub innid {
    my $host = shift;
    my $alphabet = "0123456789abcdefghijklmnopqrstuv";
    my ($newtime, $id);
    $newtime = time;
    if ($newtime == $innid_oldtime) { $innid_serial++ }
    else { $innid_serial = 0 }

    $innid_oldtime = $newtime;
    $id = "<" . intcode($newtime - 673416000, $alphabet) . "\$" .
	   intcode($$, $alphabet) ;
    $id .=  "\$" . $innid_serial    if ($innid_serial);
    $id .=  "\@" . $domain .">";
}
